PROC CopyBlok()

; CopyBlok - Copy a blok of script lines (maximum of nine).

PRIVATE
   CB,
   OverFlag,
   MoveCopy,
   BA

; NOTE: Variables CopyLines and ActualLines may not be released unless
;       this script is played an even number of times!

; Assign variables.

OverFlag = FALSE
MoveCopy = ""

; If line holding variables are already loaded, unload them.

IF ISASSIGNED(ActualLines[1]) THEN
   IF NOT ISINSERTMODE() THEN
      INS
   ENDIF

   IF CURSORLINE() <> "" THEN
      CTRLEND
      ENTER
   ENDIF

   FOR CB FROM 1 TO CopyLines
      TYPEIN ActualLines[CB]
      ENTER
   ENDFOR

   DELETELINE

   RELEASE VARS
      CopyLines,
      ActualLines
   RETURN
ENDIF

; Get input for number of lines to copy/move.

WHILE CHARWAITING()
   CopyLines = GETCHAR()
ENDWHILE

WHILE (TRUE)

MESSAGE "How many (max = 9) lines (Esc to cancel/Enter for more than 9):  "

@22,78
CopyLines = GETCHAR()

IF CopyLines = 27 THEN
   RETURN
ENDIF

IF CopyLines = 13 THEN
   OverFlag = TRUE
   QUITLOOP
ENDIF

IF CopyLines < 49 OR
   CopyLines > 57 THEN

   BEEP
   LOOP
ENDIF

QUITLOOP

ENDWHILE

; Load line holding variables.

IF OverFlag
   THEN
      OverFlag = FALSE
      @22,77
      ACCEPT "S"
         MAX 50
         MIN 1
      TO CopyLines

      ; Check for "Esc" entry.

      IF NOT retval THEN
         RETURN
      ENDIF

      ; Check for null entry.

      IF ISBLANK(CopyLines) THEN
         RETURN
      ENDIF

   ELSE
      CopyLines = NUMVAL(CHR(CopyLines))
ENDIF

; Get input as to whether to copy or move.

WHILE CHARWAITING()
   MoveCopy = GETCHAR()
ENDWHILE

WHILE (TRUE)

MESSAGE "CHOOSE -->    1 = Copy,   2 = Move   (Esc to cancel):  "

@22,78
MoveCopy = GETCHAR()

IF MoveCopy = 27 THEN
   RETURN
ENDIF

SWITCH
   CASE MoveCopy = 49  OR                              ; 1
        MoveCopy = 67  OR                              ; M
        MoveCopy = 99  OR                              ; m
        MoveCopy = 50  OR                              ; 2
        MoveCopy = 77  OR                              ; C
        MoveCopy = 109    : QUITLOOP                   ; c
   OTHERWISE              : BEEP
                            LOOP
ENDSWITCH

QUITLOOP

ENDWHILE

; Carry out the copying.

ARRAY ActualLines[CopyLines]
CTRLLEFT

FOR CB FROM 1 TO CopyLines
   ActualLines[CB] = CURSORLINE()
   DOWN
   CTRLLEFT
ENDFOR

; If a "move," delete the lines now that a copy has been made.

IF MoveCopy = 50  OR
   MoveCopy = 77  OR
   MoveCopy = 109 THEN

   FOR BA FROM 1 TO CopyLines
      UP
   ENDFOR

   FOR BA FROM 1 TO CopyLines
      DELETELINE
   ENDFOR
ENDIF

ENDPROC ; CopyBlok()

CopyBlok()
