PROC MakeLib()

; NOTE: Major credit for this scrip is due to David Kramer of Organized
;       Information Corporation, Encino, CA.

; NOTE: All scripts utilized with this "Makelib" process must be entered in
;       the MENU table and must have a final line at the end as follows:
;       WRITELIB LibName Scriptname
;
;       You must use variable names for any procedure library entries in the
;       MENU table.  Be sure that those variables are assigned prior to playing
;       this script.

PRIVATE
   NbrRows,
   Applib,
   LibText,
   PromptText,
   PromptLen,
   FormatStr,
   TargetName,
   TableName,
   ProcName,
   EscFlag,
   I

; ****************************************************************************

PROC CreateIt()

ProcName = [Script Name]

@17,0 CLEAR EOL
@17,0 ?? FORMAT("w80,ac",ProcName)

PLAY [Script Name]

ENDPROC ; CreateIt()

; ****************************************************************************

EscFlag = FALSE
RESET
CLEAR
CURSOR OFF
TableName = "Menu"
Applib = ""

CLEAR
@12,0 ?? FORMAT("w80,ac","Preparing MENU table...")

SORT TableName ON "Target Library Name" TO "Answer"

CLEAR

SCAN
   IF ISBLANK([Target Library Name]) THEN
      LOOP
   ENDIF

   IF [Process Script] = "N"  THEN
      LOOP
   ENDIF

   TargetName = [Target Library Name]
   EXECUTE "TargetName = " + TargetName

   IF Applib <> TargetName THEN
      Applib = [Target Library Name]
      EXECUTE "Applib = " + Applib
      LibText = "CREATING LIBRARY: " + TargetName
      @8,0 CLEAR EOL
      @8,5 ?? LibText
      @15,0 ?? FORMAT("w80,ac","Now writing to library -")

      IF (NOT ISBLANK([Target Library Size]))
         THEN
            CREATELIB Applib SIZE [Target Library Size]
         ELSE
            CREATELIB Applib
      ENDIF
   ENDIF

   CreateIt()

ENDSCAN

CLEAR
@12,0 CLEAR EOL
@12,0 ?? FORMAT("w80,ac","Cleaning up...")
CLEARALL
MENU
   {Ask}
   SELECT TableName
   MOVETO [Target Library Name]
   CHECK
DO_IT!
CLEARALL

VIEW "Answer"

SCAN

Applib = [Target Library Name]
EXECUTE "Applib = " + Applib
INFOLIB Applib    Right
PromptText = "Viewing procedures in: " + Applib + "  "
PromptLen  = MIN(60,LEN(PromptText))
FormatStr  = "w"+STRVAL(PromptLen)+",al"

WHILE (TRUE)
   WAIT TABLE PROMPT
      FORMAT(FormatStr,PromptText) + "|   F2   |       Esc        |",
               FILL(" ",PromptLen) + "|  Done  |  Cancel Viewing  |"
   UNTIL "F2", "Esc"

   SWITCH
     CASE retval = "F2"    : QUITLOOP
     CASE retval = "Esc"   : CLEARIMAGE
                             EscFlag = TRUE
                             QUITLOOP
     OTHERWISE             : BEEP
   ENDSWITCH

ENDWHILE  ; (TRUE)

CLEARIMAGE
CLEAR

IF EscFlag THEN
   QUITLOOP
ENDIF

ENDSCAN

CLEAR

IF ISTABLE("Answer") THEN DELETE "Answer" ENDIF
IF ISTABLE("List")   THEN DELETE "List"   ENDIF

RESET
RELEASE PROCS
   CreateIt
CURSOR NORMAL

ENDPROC ; MakeLib()

MakeLib()
